package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        anywheresoftware.b4a.keywords.Common.ToastMessageShow("This application was developed with Basic4android trial version and should not be distributed.", true);
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Serial _serial1 = null;
public anywheresoftware.b4a.randomaccessfile.AsyncStreams _astreams = null;
public static boolean _connected = false;
public anywheresoftware.b4a.objects.EditTextWrapper _textlog = null;
public anywheresoftware.b4a.objects.EditTextWrapper _textsend = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _abajo10_down() throws Exception{
 //BA.debugLineNum = 130;BA.debugLine="Sub abajo10_Down";
 //BA.debugLineNum = 131;BA.debugLine="TextSend.Text = \"abajo10\"";
mostCurrent._textsend.setText((Object)("abajo10"));
 //BA.debugLineNum = 132;BA.debugLine="MandarDato";
_mandardato();
 //BA.debugLineNum = 133;BA.debugLine="End Sub";
return "";
}
public static String  _abajo10_up() throws Exception{
 //BA.debugLineNum = 134;BA.debugLine="Sub abajo10_Up";
 //BA.debugLineNum = 135;BA.debugLine="MandarParar";
_mandarparar();
 //BA.debugLineNum = 136;BA.debugLine="End Sub";
return "";
}
public static String  _abajo8_down() throws Exception{
 //BA.debugLineNum = 159;BA.debugLine="Sub abajo8_Down";
 //BA.debugLineNum = 160;BA.debugLine="TextSend.Text = \"abajo8\"";
mostCurrent._textsend.setText((Object)("abajo8"));
 //BA.debugLineNum = 161;BA.debugLine="MandarDato";
_mandardato();
 //BA.debugLineNum = 162;BA.debugLine="End Sub";
return "";
}
public static String  _abajo8_up() throws Exception{
 //BA.debugLineNum = 175;BA.debugLine="Sub abajo8_Up";
 //BA.debugLineNum = 176;BA.debugLine="MandarParar";
_mandarparar();
 //BA.debugLineNum = 177;BA.debugLine="End Sub";
return "";
}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 30;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 31;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 32;BA.debugLine="Serial1.Initialize(\"Serial1\")";
_serial1.Initialize("Serial1");
 };
 //BA.debugLineNum = 34;BA.debugLine="Activity.LoadLayout(\"pantalla\")";
mostCurrent._activity.LoadLayout("pantalla",mostCurrent.activityBA);
 //BA.debugLineNum = 35;BA.debugLine="Activity.AddMenuItem(\"Ayuda\", \"mnuAyuda\")";
mostCurrent._activity.AddMenuItem("Ayuda","mnuAyuda");
 //BA.debugLineNum = 36;BA.debugLine="Activity.AddMenuItem(\"Acerca\", \"mnuAcerca\")";
mostCurrent._activity.AddMenuItem("Acerca","mnuAcerca");
 //BA.debugLineNum = 37;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 59;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 61;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 50;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 51;BA.debugLine="If Serial1.IsEnabled = False Then";
if (_serial1.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 52;BA.debugLine="Msgbox(\"Por favor enable Bluetooth.\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Por favor enable Bluetooth.","",mostCurrent.activityBA);
 //BA.debugLineNum = 53;BA.debugLine="salir_Click";
_salir_click();
 }else {
 //BA.debugLineNum = 55;BA.debugLine="Serial1.Listen";
_serial1.Listen(processBA);
 };
 //BA.debugLineNum = 57;BA.debugLine="End Sub";
return "";
}
public static String  _arriba10_down() throws Exception{
 //BA.debugLineNum = 121;BA.debugLine="Sub arriba10_Down";
 //BA.debugLineNum = 122;BA.debugLine="TextSend.Text = \"arriba10\"";
mostCurrent._textsend.setText((Object)("arriba10"));
 //BA.debugLineNum = 123;BA.debugLine="MandarDato";
_mandardato();
 //BA.debugLineNum = 124;BA.debugLine="End Sub";
return "";
}
public static String  _arriba10_up() throws Exception{
 //BA.debugLineNum = 125;BA.debugLine="Sub arriba10_Up";
 //BA.debugLineNum = 126;BA.debugLine="MandarParar";
_mandarparar();
 //BA.debugLineNum = 127;BA.debugLine="End Sub";
return "";
}
public static String  _arriba8_down() throws Exception{
 //BA.debugLineNum = 155;BA.debugLine="Sub arriba8_Down";
 //BA.debugLineNum = 156;BA.debugLine="TextSend.Text = \"arriba8\"";
mostCurrent._textsend.setText((Object)("arriba8"));
 //BA.debugLineNum = 157;BA.debugLine="MandarDato";
_mandardato();
 //BA.debugLineNum = 158;BA.debugLine="End Sub";
return "";
}
public static String  _arriba8_up() throws Exception{
 //BA.debugLineNum = 172;BA.debugLine="Sub arriba8_Up";
 //BA.debugLineNum = 173;BA.debugLine="MandarParar";
_mandarparar();
 //BA.debugLineNum = 174;BA.debugLine="End Sub";
return "";
}
public static String  _astreams_newdata(byte[] _buffer) throws Exception{
 //BA.debugLineNum = 64;BA.debugLine="Sub AStreams_NewData (Buffer() As Byte)";
 //BA.debugLineNum = 65;BA.debugLine="TextLog.Text =  \"->\" & BytesToString(Buffer, 0, Buffer.Length, \"ASCII\")";
mostCurrent._textlog.setText((Object)("->"+anywheresoftware.b4a.keywords.Common.BytesToString(_buffer,(int) (0),_buffer.length,"ASCII")));
 //BA.debugLineNum = 66;BA.debugLine="End Sub";
return "";
}
public static String  _conectar_click() throws Exception{
anywheresoftware.b4a.objects.collections.Map _paireddevices = null;
anywheresoftware.b4a.objects.collections.List _l = null;
int _i = 0;
int _res = 0;
 //BA.debugLineNum = 75;BA.debugLine="Sub conectar_Click";
 //BA.debugLineNum = 76;BA.debugLine="Dim PairedDevices As Map";
_paireddevices = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 77;BA.debugLine="PairedDevices = Serial1.GetPairedDevices";
_paireddevices = _serial1.GetPairedDevices();
 //BA.debugLineNum = 78;BA.debugLine="Dim l As List";
_l = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 79;BA.debugLine="l.Initialize";
_l.Initialize();
 //BA.debugLineNum = 80;BA.debugLine="For i = 0 To PairedDevices.Size - 1";
{
final int step50 = 1;
final int limit50 = (int) (_paireddevices.getSize()-1);
for (_i = (int) (0); (step50 > 0 && _i <= limit50) || (step50 < 0 && _i >= limit50); _i = ((int)(0 + _i + step50))) {
 //BA.debugLineNum = 81;BA.debugLine="l.Add(PairedDevices.GetKeyAt(i)) 'add the friendly name to the list";
_l.Add(_paireddevices.GetKeyAt(_i));
 }
};
 //BA.debugLineNum = 83;BA.debugLine="Dim res As Int";
_res = 0;
 //BA.debugLineNum = 84;BA.debugLine="res = InputList(l, \"Selecciona dispositivo\", -1) 'show list with paired devices";
_res = anywheresoftware.b4a.keywords.Common.InputList(_l,"Selecciona dispositivo",(int) (-1),mostCurrent.activityBA);
 //BA.debugLineNum = 86;BA.debugLine="If res <> DialogResponse.CANCEL Then";
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
 //BA.debugLineNum = 87;BA.debugLine="Serial1.Connect(PairedDevices.Get(l.Get(res))) 'convert the name to mac address";
_serial1.Connect(processBA,BA.ObjectToString(_paireddevices.Get(_l.Get(_res))));
 //BA.debugLineNum = 88;BA.debugLine="TextLog.Text = TextLog.Text & \"Conectando a: \" & l.Get(res)";
mostCurrent._textlog.setText((Object)(mostCurrent._textlog.getText()+"Conectando a: "+BA.ObjectToString(_l.Get(_res))));
 }else {
 //BA.debugLineNum = 90;BA.debugLine="TextLog.Text =\"Error conectando\"";
mostCurrent._textlog.setText((Object)("Error conectando"));
 };
 //BA.debugLineNum = 93;BA.debugLine="End Sub";
return "";
}
public static String  _der10_down() throws Exception{
 //BA.debugLineNum = 147;BA.debugLine="Sub der10_Down";
 //BA.debugLineNum = 148;BA.debugLine="TextSend.Text = \"derecha10\"";
mostCurrent._textsend.setText((Object)("derecha10"));
 //BA.debugLineNum = 149;BA.debugLine="MandarDato";
_mandardato();
 //BA.debugLineNum = 150;BA.debugLine="End Sub";
return "";
}
public static String  _der10_up() throws Exception{
 //BA.debugLineNum = 151;BA.debugLine="Sub der10_Up";
 //BA.debugLineNum = 152;BA.debugLine="MandarParar";
_mandarparar();
 //BA.debugLineNum = 153;BA.debugLine="End Sub";
return "";
}
public static String  _der8_down() throws Exception{
 //BA.debugLineNum = 167;BA.debugLine="Sub der8_Down";
 //BA.debugLineNum = 168;BA.debugLine="TextSend.Text = \"derecha7\"";
mostCurrent._textsend.setText((Object)("derecha7"));
 //BA.debugLineNum = 169;BA.debugLine="MandarDato";
_mandardato();
 //BA.debugLineNum = 170;BA.debugLine="End Sub";
return "";
}
public static String  _der8_up() throws Exception{
 //BA.debugLineNum = 178;BA.debugLine="Sub der8_Up";
 //BA.debugLineNum = 179;BA.debugLine="MandarParar";
_mandarparar();
 //BA.debugLineNum = 180;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 20;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 22;BA.debugLine="Dim AStreams As AsyncStreams";
mostCurrent._astreams = new anywheresoftware.b4a.randomaccessfile.AsyncStreams();
 //BA.debugLineNum = 23;BA.debugLine="Dim connected As Boolean";
_connected = false;
 //BA.debugLineNum = 25;BA.debugLine="Dim TextLog As EditText";
mostCurrent._textlog = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim TextSend As EditText";
mostCurrent._textsend = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 28;BA.debugLine="End Sub";
return "";
}
public static String  _iz10_down() throws Exception{
 //BA.debugLineNum = 139;BA.debugLine="Sub iz10_Down";
 //BA.debugLineNum = 140;BA.debugLine="TextSend.Text = \"izquierda10\"";
mostCurrent._textsend.setText((Object)("izquierda10"));
 //BA.debugLineNum = 141;BA.debugLine="MandarDato";
_mandardato();
 //BA.debugLineNum = 142;BA.debugLine="End Sub";
return "";
}
public static String  _iz10_up() throws Exception{
 //BA.debugLineNum = 143;BA.debugLine="Sub iz10_Up";
 //BA.debugLineNum = 144;BA.debugLine="MandarParar";
_mandarparar();
 //BA.debugLineNum = 145;BA.debugLine="End Sub";
return "";
}
public static String  _iz8_down() throws Exception{
 //BA.debugLineNum = 163;BA.debugLine="Sub iz8_Down";
 //BA.debugLineNum = 164;BA.debugLine="TextSend.Text = \"izquierda7\"";
mostCurrent._textsend.setText((Object)("izquierda7"));
 //BA.debugLineNum = 165;BA.debugLine="MandarDato";
_mandardato();
 //BA.debugLineNum = 166;BA.debugLine="End Sub";
return "";
}
public static String  _iz8_up() throws Exception{
 //BA.debugLineNum = 181;BA.debugLine="Sub iz8_Up";
 //BA.debugLineNum = 182;BA.debugLine="MandarParar";
_mandarparar();
 //BA.debugLineNum = 183;BA.debugLine="End Sub";
return "";
}
public static String  _mandardato() throws Exception{
String _s = "";
byte[] _buffer = null;
 //BA.debugLineNum = 106;BA.debugLine="Sub MandarDato";
 //BA.debugLineNum = 107;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 108;BA.debugLine="Dim s As String";
_s = "";
 //BA.debugLineNum = 109;BA.debugLine="s = TextSend.Text  & Chr(10)";
_s = mostCurrent._textsend.getText()+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)));
 //BA.debugLineNum = 110;BA.debugLine="Dim buffer() As Byte";
_buffer = new byte[(int) (0)];
;
 //BA.debugLineNum = 111;BA.debugLine="buffer = s.GetBytes(\"UTF8\")";
_buffer = _s.getBytes("UTF8");
 //BA.debugLineNum = 112;BA.debugLine="AStreams.Write(buffer)";
mostCurrent._astreams.Write(_buffer);
 };
 //BA.debugLineNum = 114;BA.debugLine="End Sub";
return "";
}
public static String  _mandarparar() throws Exception{
 //BA.debugLineNum = 116;BA.debugLine="Sub MandarParar";
 //BA.debugLineNum = 117;BA.debugLine="TextSend.Text = \"parar\"";
mostCurrent._textsend.setText((Object)("parar"));
 //BA.debugLineNum = 118;BA.debugLine="MandarDato";
_mandardato();
 //BA.debugLineNum = 119;BA.debugLine="End Sub";
return "";
}
public static String  _mnuacerca_click() throws Exception{
 //BA.debugLineNum = 40;BA.debugLine="Sub mnuAcerca_Click";
 //BA.debugLineNum = 41;BA.debugLine="Msgbox(\"xsetaseta@gmail.com\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("xsetaseta@gmail.com","",mostCurrent.activityBA);
 //BA.debugLineNum = 42;BA.debugLine="TextLog.Text = TextLog.Text & \" xsetaseta@gmail.com \"";
mostCurrent._textlog.setText((Object)(mostCurrent._textlog.getText()+" xsetaseta@gmail.com "));
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _mnuayuda_click() throws Exception{
 //BA.debugLineNum = 45;BA.debugLine="Sub mnuAyuda_Click";
 //BA.debugLineNum = 46;BA.debugLine="Msgbox(\"Android->arduino->Auto\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Android->arduino->Auto","",mostCurrent.activityBA);
 //BA.debugLineNum = 47;BA.debugLine="TextLog.Text = TextLog.Text & \" Android->arduino->Auto \"";
mostCurrent._textlog.setText((Object)(mostCurrent._textlog.getText()+" Android->arduino->Auto "));
 //BA.debugLineNum = 48;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 17;BA.debugLine="Dim Serial1 As  Serial";
_serial1 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 18;BA.debugLine="End Sub";
return "";
}
public static String  _salir_click() throws Exception{
 //BA.debugLineNum = 68;BA.debugLine="Sub salir_Click";
 //BA.debugLineNum = 69;BA.debugLine="Serial1.Disconnect";
_serial1.Disconnect();
 //BA.debugLineNum = 70;BA.debugLine="TextLog.Text =  \" Desconectado  \"";
mostCurrent._textlog.setText((Object)(" Desconectado  "));
 //BA.debugLineNum = 71;BA.debugLine="connected = False";
_connected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 72;BA.debugLine="Msgbox(\"Programa terminado\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Programa terminado","",mostCurrent.activityBA);
 //BA.debugLineNum = 73;BA.debugLine="ExitApplication";
anywheresoftware.b4a.keywords.Common.ExitApplication();
 //BA.debugLineNum = 74;BA.debugLine="End Sub";
return "";
}
public static String  _serial1_connected(boolean _success) throws Exception{
 //BA.debugLineNum = 95;BA.debugLine="Sub Serial1_Connected (Success As Boolean)";
 //BA.debugLineNum = 97;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 98;BA.debugLine="AStreams.Initialize (Serial1.InputStream ,Serial1.OutputStream ,\"AStreams\")";
mostCurrent._astreams.Initialize(processBA,_serial1.getInputStream(),_serial1.getOutputStream(),"AStreams");
 //BA.debugLineNum = 99;BA.debugLine="TextLog.Text = TextLog.Text & \"  Conectado  \"";
mostCurrent._textlog.setText((Object)(mostCurrent._textlog.getText()+"  Conectado  "));
 //BA.debugLineNum = 100;BA.debugLine="connected = True";
_connected = anywheresoftware.b4a.keywords.Common.True;
 }else {
 //BA.debugLineNum = 102;BA.debugLine="connected = False";
_connected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 103;BA.debugLine="Msgbox(LastException.Message, \"Error de conexion.\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"Error de conexion.",mostCurrent.activityBA);
 };
 //BA.debugLineNum = 105;BA.debugLine="End Sub";
return "";
}
}
